<?php 

namespace Teknisa\DF\Modules\Entrada\Controllers;

/* Bibliotecas */
use NFePHP\NFe\MakeNFe;
use NFePHP\NFe\ToolsNFe;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;

/* Classes DF */
use Teknisa\DF\Modules\Entrada\Services\NumeracaoTransmissaoNfeService;

class NumeracaoTransmissaoNfeController {
    
    public function __construct(NumeracaoTransmissaoNfeService $numeracaoTransmissaoNfeService) {
        $this->numeracaoTransmissaoNfeService = $numeracaoTransmissaoNfeService;
        set_time_limit(0);
    }
    
    
    public function getSerieNfe(Request\Row $request, Response $response) {
        $row = $request->getRow();
        
        $dataSet = $this->numeracaoTransmissaoNfeService->getSerieNfe($row);
        
        $response->addDataset(new DataSet("NumeracaoSerieNfe",  $dataSet));
    }
    
    public function getNovoCodigo(Request\Row $request, Response $response) {
        $row = $request->getRow();
        
        $dataSet = $this->numeracaoTransmissaoNfeService->getNovoCodigo($row);
        
        $response->addDataset(new DataSet("NumeracaoNovoCodigo",  $dataSet));
    }
    
}