<?php
namespace Teknisa\DF\Services;

use Teknisa\Libs\Util\Environment;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO;


class Ger98500TipoGestaoFiscalService{

	protected $environment;
	protected $entityManager;
	protected $dataSourceManager;

	public function __construct(Environment $environment, \Doctrine\ORM\EntityManager $entityManager ,$dataSourceManager){
		$this->environment = $environment;
		$this->entityManager = $entityManager;
		$this->dataSourceManager = $dataSourceManager;
	}


	public function verficarUnidade($row){
		$conditions = $this->condicaoVerificarUnidade($row);
		$resultadoBanco = $this->buscar($conditions,'filtpfaturfis_filial_tpfaturfis');
		return $resultadoBanco;
	}

	public function deletar($row){
		try {
	        $connection = $this->entityManager->getConnection();
	       	$connection->beginTransaction();
	        $conditions = $this->condicaoVerificarUnidade($row);
			$resultadoBanco = $this->buscar($conditions,'filtpfaturfis_filial_tpfaturfis');

	    	if(!empty($resultadoBanco->getRows())){
		    	$this->delete($resultadoBanco);
	    	}

	        $array[] = $row;
	        $dataSet = new DataSet('tpfaturfis', $array);
	        $this->delete($dataSet);


			$connection->commit();
		}catch (\Exception $e) {
    		$this->entityManager->rollback();
        	throw $e;
        }
	}

	public function condicaoVerificarUnidade($row) {
	    $conditions = array(
	      array(
	        "value" => $this->environment->getNrOrgTrab(),
	        "operator" => "=",
	        "columnName" => "NRORG"
	      ),
	      array(
	        "value" => $row['CDTPFATURFIS'],
	        "operator" => "=",
	        "columnName" => "CDTPFATURFIS"
	      )
	    );
	    return $conditions;
	}

	public function buscar($conditions, $dataSourceName){
		$filterCriteria = new FilterCriteria($dataSourceName,$conditions);
		return  $this->dataSourceManager->findBy($filterCriteria);
	}

	public function delete($dataSet){
    	$this->dataSourceManager->delete($dataSet);
    	$this->entityManager->flush();
	}
}